FloatTable donnees;
float dmin, dmax;
int amin, amax;
int[] annees;
float traceX1, traceY1, traceX2, traceY2;
// La colonne de données actuellement utilisée.
int colonne = 0;
// Le nombre de colonnes.
int ncol;
// La police de caractères.
PFont police;

void setup() {
    size(720, 405);

    donnees = new FloatTable("lait-the-cafe.tsv");
    ncol = donnees.getColumnCount();        // Le nombre de colonnes.
    dmin = 0;
    dmax = donnees.getTableMax();
    annees = int(donnees.getRowNames());
    amin = annees[0];
    amax = annees[annees.length - 1];

    traceX1 = 50;
    traceY1 = 50;
    traceX2 = width - traceX1;
    traceY2 = height - traceY1;

    police = createFont("SansSerif", 20);
    textFont(police);

    smooth();
}

void draw() {
    background(224);

    fill(255);
    rectMode(CORNERS);
    noStroke();
    rect(traceX1, traceY1, traceX2, traceY2);
    
    // Dessine le titre.
    fill(0);
    textSize(20);
    text(donnees.getColumnName(colonne), traceX1, traceY1 - 10);

    strokeWeight(5);
    stroke(#5679C1);
    dessinePointsDonnees(colonne); // ! On utilise la colonne courante.
}

void dessinePointsDonnees(int col) {
    int lignes = donnees.getRowCount();
    for(int ligne = 0; ligne < lignes; ligne++) {
        if(donnees.isValid(ligne, col)) {
            float valeur = donnees.getFloat(ligne, col);
            float x = map(annees[ligne], amin, amax, traceX1, traceX2);
            float y = map(valeur, dmin, dmax, traceY2, traceY1);
            point(x, y);
        }
    }
}

void keyPressed() {
    if(keyCode == LEFT) {
        colonne = colonne == 0 ? ncol - 1 : (colonne - 1);
    }else if(keyCode == RIGHT) {
        colonne = (colonne + 1) % ncol;
    }
}